<template src="./template.html"/>
<style scoped src="./stylesheet.scss" lang="scss"/>

<script>
    import axios from "axios";
    import { store } from "../../../../store/store";

    import VueUploadMultipleImage from "vue-upload-multiple-image";
    import ShopForm from "../../../../components/ShopForm/ShopForm";

    export default {
        name: "ShopEdit",
        components: {
            VueUploadMultipleImage,
            ShopForm
        },
        data() {
            return {
                shop: {
                    images: []
                },

                shopFormState: true,
                initialImages: [],
                isImagesCompiled: true,
            }
        },
        mounted() {
            axios({
                method: "GET",
                "url": "/store/" + this.$route.params.shopId,
                headers: {
                    Authorization: 'Bearer ' + store.getters.token
                },
                data: {}
            }).then((response) => {
                this.shop = response.data;
                this.shop.paymentTypesId = [];
                this.shop.paymentTypes.forEach((paymentType) => {
                    this.shop.paymentTypesId.push(paymentType.id);
                });
                this.shop.images = response.data.imagesPath.slice();
                this.initialImages = response.data.imagesPath.slice();
                this.initialImages[0].highlight = 1;
                this.initialImages[0].default = 1;
            }).catch((error) => {
                this.$bvModal.msgBoxOk(error.response.data.error, {
                    title: 'Attenzione',
                    okVariant: 'primary'
                })
            });
        },
        computed: {
            buttonDisabled() {
                return this.shopFormState || this.isButtonDisabled || !this.isImagesCompiled;
            }
        },
        methods: {
            editShop() {
                if (this.shop.paymentTypesId.length === 0) {
                    this.$bvModal.msgBoxOk('Compila le opzioni di pagamento prima di modificare', {
                        title: 'Attenzione!',
                        okVariant: 'primary',
                        headerClass: 'p-2 border-bottom-0',
                        footerClass: 'p-2 border-top-0',
                    });
                } else {
                    axios({
                        method: "PUT",
                        "url": "/store/admin/" + this.$route.params.shopId,
                        headers: {
                            Authorization: 'Bearer ' + store.getters.token
                        },
                        data: this.shop
                    }).then(() => {
                        this.$bvModal.msgBoxOk('Il negozio è stato modificato correttamente', {
                            title: 'Ottimo!',
                            okVariant: 'success',
                            headerClass: 'p-2 border-bottom-0',
                            footerClass: 'p-2 border-top-0',
                            centered: true
                        }).then(() => {
                            //this.$router.push('/dashboard/lista-negozi');
                            this.$router.back();
                        });
                    }).catch((error) => {
                        this.$bvModal.msgBoxOk(error.response.data.error, {
                            title: 'Attenzione',
                            okVariant: 'primary'
                        });
                    });
                }
            },
            uploadImageSuccess(formData, index, fileList) {
                this.shop.images = fileList;
                this.isImagesCompiled = this.shop.images.length !== 0;
            },
            beforeRemove(index, done, fileList) {
                let r = confirm("Rimuovere l'immagine?");
                if (r) {
                    done();
                    this.shop.images = fileList;
                }
                this.isImagesCompiled = this.shop.images.length !== 0;
            },
            editImage(formData, index, fileList) {
                delete fileList[index].id;
                this.shop.images = fileList;
                this.isImagesCompiled = this.shop.images.length !== 0;
            },
            userInput(value) {
                this.shopFormState = value;
            },
            markIsPrimary(index, fileList) {
                this.shop.images = fileList;
            }
        }
    }
</script>
